
' - NOT REQUIRED -
' -----------------------------------------------------------------------------------------------------------------
' Microsoft Speech Platform - Software Development Kit (SDK) (Version 10.2)
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=1b1604d3-4f66-4241-9a21-90a294a5c9a4&displaylang=en
'
' Reference to: C:\Program Files\Microsoft Speech Platform SDK\Assembly\Microsoft.Speech.dll
' -----------------------------------------------------------------------------------------------------------------

' - REQUIRED -
'------------------------------------------------------------------------------------------------------------------
' Microsoft Speech Platform - Server Runtime (Version 10.2) 
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=bb0f72cb-b86b-46d1-bf06-665895a313c7&displaylang=en
'
' Languages you wish for TTS and SR, among 26 languages
' http://www.microsoft.com/downloads/en/details.aspx?FamilyID=47ffd4e5-e682-4228-8058-dd895252a3c3&displaylang=en
'
' Reference to: C:\WINDOWS\assembly\GAC_MSIL\Microsoft.Speech\10.2.0.0__31bf3856ad364e35\Microsoft.Speech.dll
'------------------------------------------------------------------------------------------------------------------

' - REQUIRED -
'---------------------------------------------------------------------------------------
' If you don't have the culture files installed you could get an error
' For a Culture the files to install are two, one for TTS and one for SR.
' For en-US: 'MSSpeech_TTS_en-US_Helen.msi' and 'MSSpeech_SR_en-US_TELE.msi' 
' For it-IT: 'MSSpeech_TTS_it-IT_Lucia.msi' and 'MSSpeech_SR_it-IT_TELE.msi' 
'---------------------------------------------------------------------------------------

Imports System.Windows.Forms
Imports System.Collections.Generic
Imports System.Drawing
Imports System.Media
Imports Microsoft.Speech.Recognition
Imports Microsoft.Speech.Synthesis

Partial Public Class Form1
    Inherits Form

    Private TTS_SlotsAreEnabled As Boolean = True
    ' --------------------------------------------------- TTS - TEXT TO SPEECH
    Private _tts As SpeechSynthesizer = Nothing
    Private _player As New SoundPlayer()
    ' --------------------------------------------------- SR - SPEECH RECOGNITION
    Private _sre As SpeechRecognitionEngine = Nothing
    Private _strCulture As String = ""
    Private _recognizing As Boolean

    Private Sub Form1_Load1(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Me.Text = AppTitleAndVersion()
        ' --------------------------------- create TTS and the event SpeakCompleted
        Try
            'Error 1
            _tts = New SpeechSynthesizer()
            AddHandler _tts.SpeakCompleted, AddressOf tts_SpeakCompleted
        Catch
            ShowErrorMessage()
        End Try
        ' --------------------------------- prepare the voice list
        FillVoiceList()
        SetVoiceIndex(0)
        ' --------------------------------- start
        Load_INI()
        SplitContainer1.Panel1MinSize = 62
        SplitContainer1.Panel2MinSize = 200
        SplitContainer2.Panel1MinSize = 240
        SplitContainer2.Panel2MinSize = 220
        SetFormMinimumSize()
        SetBtnSayTypeColors()
        ' --------------------------------- start
        SetSelectedVoice()
        ParseTtsLines()
        ' ---------------------------------
        ParseSrLines()
        UpdateRunStatus()
        If Running Then SayValidWords()
        UpdateStopRecogStatus()
        ' --------------------------------- 
        EventsAreEnabled = True
        Timer1.Start()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        PlayerIsPlaying = False
        StopSREngine()
        Save_INI()
    End Sub

    Private Sub Form1_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        LimitFormPosition(Me)
    End Sub

    Private Sub SplitContainer1_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved
        SetFormMinimumSize()
    End Sub
    Private Sub SplitContainer2_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer2.SplitterMoved
        SetFormMinimumSize()
    End Sub
    Private Sub SetFormMinimumSize()
        MinimumSize = New Size(SplitContainer2.SplitterDistance + SplitContainer2.Panel2MinSize + 40, _
                               SplitContainer1.SplitterDistance + SplitContainer1.Panel2MinSize + 80)
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' ------------------------------------------------- update ProgressBar
        If _recognizing Then
            ProgressBar1.ForeColor = Color.Green
            ProgressBar1.Value = _sre.AudioLevel
        Else
            ProgressBar1.ForeColor = Color.OrangeRed
            ProgressBar1.Value = 100
        End If
        ' ------------------------------------------------- test TTS Slots
        If TTS_SlotsAreEnabled Then TestSlotsForTTS()
        ' ------------------------------------------------- test RunSlot
        If RunSlot > -1 Then
            If Slots.ReadSlot_NoNan(RunSlot) > 500 Then
                If Not Running Then Running = True : StartSREngine()
            Else
                If Running Then Running = False : StopSREngine()
            End If
        End If
    End Sub

    Private Sub ShowErrorMessage()
        MessageBox.Show("Please install the Speech Platform Runtime (32 or 64 bit)" + vbCrLf + _
                        "and the preferred languages TTS and SR voices", _
                        "Theremino Voice IN-OUT")
        Diagnostics.Process.Start(".\Installers")
        End
    End Sub


    ' ====================================================================
    '  BUTTONS AND CHECKBOX
    ' ====================================================================
    Private Sub btn_RecogLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecogLoad.Click
        SaveRecogFile()
        RecogLoad()
        ParseSrLines()
        StartSREngine()
        SayValidWords()
    End Sub
    Private Sub btn_RecogSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecogSave.Click
        RecogSave()
    End Sub
    Private Sub btn_SpeechLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SpeechLoad.Click
        SaveSpeechFile()
        SpeechLoad()
        ParseTtsLines()
    End Sub
    Private Sub btn_SpeechSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SpeechSave.Click
        SpeechSave()
    End Sub


    ' =================================================================================
    '  SAY TYPES
    ' =================================================================================
    Friend Enum SayTypes
        SayNothing
        SayOneWord
        SayAllWords
    End Enum
    Friend SayType As SayTypes
    Private Sub btn_SayType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SayType.Click
        Select Case SayType
            Case SayTypes.SayNothing : SayType = SayTypes.SayOneWord
            Case SayTypes.SayOneWord : SayType = SayTypes.SayAllWords
            Case Else : SayType = SayTypes.SayNothing
        End Select
        SetBtnSayTypeColors()
    End Sub

    Private Sub SetBtnSayTypeColors()
        Select Case SayType
            Case SayTypes.SayNothing
                btn_SayType.BackColor = Color.FromArgb(240, 240, 240)
                btn_SayType.FlatAppearance.MouseOverBackColor = Color.FromArgb(250, 250, 250)
                btn_SayType.Text = "Say nothing"
            Case SayTypes.SayOneWord
                btn_SayType.BackColor = Color.FromArgb(250, 240, 120)
                btn_SayType.FlatAppearance.MouseOverBackColor = Color.FromArgb(250, 250, 160)
                btn_SayType.Text = "Say one word"
            Case SayTypes.SayAllWords
                btn_SayType.BackColor = Color.FromArgb(250, 200, 100)
                btn_SayType.FlatAppearance.MouseOverBackColor = Color.FromArgb(250, 220, 130)
                btn_SayType.Text = "Say all words"
        End Select
    End Sub

    Friend Running As Boolean = True
    Private Sub btn_Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Run.Click
        Running = Not Running
        UpdateRunStatus()
    End Sub
    Private Sub UpdateRunStatus()
        If Running Then
            btn_Run.BackColor = Color.Orange
            StartSREngine()
        Else
            btn_Run.BackColor = Color.WhiteSmoke
            StopSREngine()
        End If
    End Sub

    Friend StopRecognition As Boolean = True
    Private Sub btn_StopRecog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_StopRecog.Click
        StopRecognition = Not StopRecognition
        UpdateStopRecogStatus()
    End Sub
    Private Sub UpdateStopRecogStatus()
        If StopRecognition Then
            btn_StopRecog.BackColor = Color.Orange
        Else
            btn_StopRecog.BackColor = Color.WhiteSmoke
        End If
    End Sub


    ' ====================================================================
    '  TEXT TO SPEECH
    ' ====================================================================
    Private Sub txt_TTS_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles txt_TTS.MouseClick
        TTS_SlotsAreEnabled = False
        txt_TTS.BackColor = Color.LightSalmon
    End Sub
    Private Sub txt_TTS_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_TTS.MouseLeave
        If Not EventsAreEnabled Then Return
        ParseTtsLines()
        SaveSpeechFile()
        TTS_SlotsAreEnabled = True
        txt_TTS.BackColor = Color.White
    End Sub

    Friend Function GetVoiceIndex() As Int32
        Return list_TTSVoices.SelectedIndices(0)
    End Function

    Friend Sub SetVoiceIndex(ByVal index As Int32)
        list_TTSVoices.SelectedItems.Clear()
        If index >= list_TTSVoices.Items.Count Then
            index = list_TTSVoices.Items.Count - 1
        End If
        If index >= 0 Then
            list_TTSVoices.Items(index).Selected = True
        End If
    End Sub

    Private Sub btn_Microphone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Microphone.Click
        Shell("control mmsys.cpl,,1", AppWinStyle.NormalFocus)
    End Sub

    ' ====================================================================
    '  TEXT TO SPEECH - SPEECH TO AUDIO
    ' ====================================================================
    Private Sub btn_Speech_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_Speech.Click
        If txt_TTS.SelectionLength = 0 Then
            TextBox_SelectWholeLine(txt_TTS)
        End If
        If txt_TTS.SelectedText <> "" Then
            _tts.Rate = 1
            Speak(txt_TTS.SelectedText)
        Else
            MsgBox("Please select some text", MsgBoxStyle.OkOnly)
        End If
    End Sub


    ' ====================================================================
    '  TEXT TO SPEECH - ASYNC VERSION
    ' ====================================================================
    'Private PlayerIsPlaying As Boolean = False
    'Public Sub Speak(ByVal text As String)
    '    If PlayerIsPlaying Then Return
    '    PlayerIsPlaying = True
    '    _player.Stream = New System.IO.MemoryStream()
    '    _tts.SetOutputToWaveStream(_player.Stream)
    '    _tts.SpeakAsync(text)
    'End Sub
    'Private Sub tts_SpeakCompleted(ByVal sender As Object, ByVal e As SpeakCompletedEventArgs)
    '    ' ----------------------------- synthesis is completed so play the audio
    '    _player.Stream.Position = 0
    '    _player.Play()
    '    PlayerIsPlaying = False
    'End Sub


    ' ====================================================================
    '  TEXT TO SPEECH - VERSION WITH THREAD TO WAIT SPEECH END
    ' ====================================================================
    Private PlayerIsPlaying As Boolean = False
    Private PlayThread As Threading.Thread

    Public Sub Speak(ByVal text As String)
        If PlayerIsPlaying Then Return
        PlayerIsPlaying = True
        ' ----------------------------- 
        If StopRecognition Then
            RecognizePause()
        End If
        ' ----------------------------- 
        _player.Stream = New System.IO.MemoryStream()
        _tts.SetOutputToWaveStream(_player.Stream)
        _tts.SpeakAsync(text)
    End Sub

    Private Sub tts_SpeakCompleted(ByVal sender As Object, ByVal e As SpeakCompletedEventArgs)
        PlayThread = New Threading.Thread(AddressOf PlayThreadFunction)
        PlayThread.Start()
    End Sub

    Private Sub PlayThreadFunction()
        ' ----------------------------- synthesis is completed so play the audio
        _player.Stream.Position = 0
        _player.PlaySync()
        ' -----------------------------
        RecognizeRestart()
        ' ----------------------------- 
        PlayerIsPlaying = False
    End Sub


    ' ====================================================================
    '  TEXT TO SPEECH SENTENCES FROM SLOTS
    ' ====================================================================
    Private Sub FillVoiceList()
        list_TTSVoices.View = View.Details
        list_TTSVoices.FullRowSelect = True
        list_TTSVoices.HideSelection = False
        list_TTSVoices.Columns.Add("Name", 350, HorizontalAlignment.Left)
        list_TTSVoices.Columns.Add("Culture", 50, HorizontalAlignment.Left)
        list_TTSVoices.Columns.Add("Gender", 50, HorizontalAlignment.Left)
        list_TTSVoices.Columns.Add("Age", 50, HorizontalAlignment.Left)
        list_TTSVoices.Columns.Add("Id", 200, HorizontalAlignment.Left)
        For Each voice As InstalledVoice In _tts.GetInstalledVoices()
            Dim listItem As New ListViewItem(voice.VoiceInfo.Name)
            listItem.SubItems.Add(voice.VoiceInfo.Culture.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Gender.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Age.ToString())
            listItem.SubItems.Add(voice.VoiceInfo.Id.ToString())
            list_TTSVoices.Items.Add(listItem)
        Next
        'lbl_InstalledVoices.Text = "Installed Voices  ( " + _tts.GetInstalledVoices.Count.ToString + " voices )"
    End Sub

    Private Sub list_TTSVoices_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles list_TTSVoices.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SetSelectedVoice()
    End Sub

    Private Sub SetSelectedVoice()
        If list_TTSVoices.SelectedItems.Count > 0 Then
            Try
                _tts.SpeakAsyncCancelAll()
                _tts.SelectVoice(list_TTSVoices.SelectedItems(0).Text)
                ' ------------------------------------ get Voice Culture
                _strCulture = list_TTSVoices.SelectedItems(0).SubItems(1).Text
                ' ------------------------------------ set also Speech Recog to this culture
                StartSREngine()
            Catch
            End Try
        End If
    End Sub


    ' ====================================================================
    '  TEXT TO SPEECH SENTENCES FROM SLOTS
    ' ====================================================================
    Private Structure TTS_Sentence
        Dim slot As Int32
        Dim textindex As Int32
        Dim ready As Boolean
        Dim text As String
        Dim speed As Int32
        Sub Init()
            slot = 1
            textindex = 1
            ready = True
            text = ""
            speed = 1
        End Sub
    End Structure

    Private TTS_Sentences(-1) As TTS_Sentence

    Private Sub ParseTtsLines()
        Dim l As String
        Dim lines() As String = txt_TTS.Text.Split(Chr(10))
        ReDim TTS_Sentences(-1)
        Dim ts As TTS_Sentence
        ts.text = ""
        For i As Int32 = 0 To lines.Length - 1
            l = lines(i)
            l = l.Trim
            If l.ToLower.StartsWith("cmd_") Then
                ' ------------------------------------------ decode commands
                AddTtsSentenceToSentencesArray(ts)
                l = ReplaceMultipleSpacesAndTrim(l)
                Dim sa() As String = l.Split(" "c)
                Select Case sa(0).ToLower
                    Case "cmd_slot"
                        If sa.Length >= 2 Then
                            ts = New TTS_Sentence
                            ts.Init()
                            ts.slot = CInt(Val(sa(1)))
                            ts.textindex = 1
                            ts.speed = 0
                        Else
                            MessageBox.Show("Unrecognized command """ + l + _
                                            """", "Message from Theremino Voice", _
                                            MessageBoxButtons.OK)
                        End If
                        If sa.Length >= 4 Then
                            If sa(2).ToLower = "text" Then
                                ts.textindex = CInt(Val(sa(3)))
                            Else
                                MessageBox.Show("Unrecognized command """ + l + _
                                                """", "Message from Theremino Voice", _
                                                MessageBoxButtons.OK)
                            End If
                        End If
                        If sa.Length = 6 Then
                            If sa(4).ToLower = "speed" Then
                                ts.speed = CInt(Val(sa(5)))
                                If ts.speed > 10 Then ts.speed = 10
                                If ts.speed < -10 Then ts.speed = -10
                            Else
                                MessageBox.Show("Unrecognized command """ + l + _
                                               """", "Message from Theremino Voice", _
                                               MessageBoxButtons.OK)
                            End If
                        End If
                    Case Else
                        MessageBox.Show("Unrecognized command """ + l + _
                                            """", "Message from Theremino Voice", _
                                            MessageBoxButtons.OK)
                End Select
            Else
                ' ------------------------------------------ add text line
                ts.text += l
            End If
        Next
        AddTtsSentenceToSentencesArray(ts)
    End Sub

    Private Sub AddTtsSentenceToSentencesArray(ByRef ts As TTS_Sentence)
        If ts.text = "" Then Return
        ReDim Preserve TTS_Sentences(TTS_Sentences.Length)
        TTS_Sentences(TTS_Sentences.Length - 1) = ts
        ts.text = ""
    End Sub

    Private Sub TestSlotsForTTS()
        For i As Int32 = 0 To TTS_Sentences.Length - 1
            With TTS_Sentences(i)
                If Slots.ReadSlot_NoNan(.slot) = .textindex Then
                    If .ready Then
                        .ready = False
                        _tts.Rate = .speed
                        Speak(.text)
                    End If
                Else
                    .ready = True
                End If
            End With
        Next
    End Sub


    ' ====================================================================
    '  SPEECH RECOGNITION
    ' ====================================================================
    Private SRTextChanged As Boolean = False
    Private Sub txt_ValidWords_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles txt_ValidWords.MouseClick
        StopSREngine()
        txt_ValidWords.BackColor = Color.LightSalmon
    End Sub
    Private Sub txt_ValidWords_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_ValidWords.TextChanged
        If Not EventsAreEnabled Then Return
        SRTextChanged = True
    End Sub
    Private Sub txt_ValidWords_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_ValidWords.MouseLeave
        If Not EventsAreEnabled Then Return
        If SRTextChanged Then
            SaveRecogFile()
            ParseSrLines()
            SRTextChanged = False
            If SayType >= SayTypes.SayOneWord Then
                SayValidWords()
            Else
                StartSREngine()
            End If
        Else
            StartSREngine()
        End If
        txt_ValidWords.BackColor = Color.White
    End Sub

    Private Sub RecognizePause()
        If _sre IsNot Nothing Then
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
            _recognizing = False
        End If
    End Sub
    Private Sub RecognizeRestart()
        If Not Running Then Return
        If _sre IsNot Nothing Then
            Try
                _sre.RecognizeAsync(RecognizeMode.Multiple)
            Catch
            End Try
            _recognizing = True
        End If
    End Sub

    Private Sub StopSREngine()
        If _sre IsNot Nothing Then
            ' ------------------------------------------ remove SpeechRecognized event handler
            RemoveHandler _sre.SpeechRecognized, _
                          AddressOf sre_SpeechRecognized
            ' ------------------------------------------
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
        End If
        _recognizing = False
    End Sub

    Private Sub StartSREngine()
        If Not Running Then Return
        ' ------------------------------------------
        If _sre IsNot Nothing Then
            _sre.RecognizeAsyncCancel()
            _sre.RecognizeAsyncStop()
        End If
        ' ------------------------------------------ 
        Try
            _sre = New SpeechRecognitionEngine(New Globalization.CultureInfo(_strCulture))
        Catch
            ShowErrorMessage()
        End Try
        ' ------------------------------------------ create choices
        Dim words As New Choices()
        For Each w As SR_Word In SR_Words
            words.Add(w.word)
        Next
        words.Add(" ")
        ' ------------------------------------------ create grammar and load into SR
        Dim gb As New GrammarBuilder()
        gb.Culture = New System.Globalization.CultureInfo(_strCulture)
        gb.Append(words)
        _sre.LoadGrammar(New Grammar(gb))
        'Text = _sre.Grammars.Count.ToString
        ' ------------------------------------------ set recog props
        '_sre.MaxAlternates = 1
        '_sre.BabbleTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.InitialSilenceTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.EndSilenceTimeout = TimeSpan.FromMilliseconds(1)
        '_sre.EndSilenceTimeoutAmbiguous = TimeSpan.FromMilliseconds(1)
        ' ------------------------------------------ set SpeechRecognized event handler
        AddHandler _sre.SpeechRecognized, _
                      AddressOf sre_SpeechRecognized
        ' ------------------------------------------ start
        _sre.SetInputToDefaultAudioDevice()
        _sre.RecognizeAsync(RecognizeMode.Multiple)
        _recognizing = True
    End Sub

    Private Function ReplaceMultipleSpacesAndTrim(ByVal s As String) As String
        s = s.Replace(vbTab, " ")
        s = s.Replace(vbCr, " ")
        s = s.Replace(vbLf, " ")
        While s.Contains("  ")
            s = s.Replace("  ", " ")
        End While
        Return s.Trim
    End Function

    Private Sub sre_SpeechRecognized(ByVal sender As Object, ByVal e As SpeechRecognizedEventArgs)
        DecodeRecognizedWorld(e.Result)
    End Sub


    ' ====================================================================
    '  SPLIT SR TextBox to WORDS
    ' ====================================================================
    Private Structure SR_Word
        Dim lineIndex As Int32
        Dim word As String
        Dim cmd As String
        Dim cmdParams() As String
        Dim values() As Single
    End Structure

    Private SR_Words(-1) As SR_Word

    Private Sub ParseSrLines()
        FirstSlot = 1
        RunSlot = -1
        Confidence = 0.6
        ReDim SR_Words(-1)
        Dim l As String
        Dim lines() As String = txt_ValidWords.Text.Split(Chr(13))
        For LineIndex As Int32 = 0 To lines.Length - 1
            l = lines(LineIndex)
            l = ReplaceMultipleSpacesAndTrim(l)
            l = l.Trim
            If l.StartsWith("-") Or l.StartsWith("'") Or l.StartsWith("//") Then Continue For
            If l <> "" Then
                Dim sa() As String = l.Split(" "c)
                If sa.Length > 0 Then
                    ' ------------------------------------------ decode commands
                    If sa(0).ToLower.StartsWith("cmd_") Then
                        Select Case sa(0).ToLower
                            Case "cmd_prefix"
                                SayValidPrefixText = CollectFields(sa)
                            Case "cmd_firstslot"
                                FirstSlot = CInt(Val(CollectFields(sa)))
                            Case "cmd_confidence"
                                Confidence = CSng(Val(CollectFields(sa)))
                            Case "cmd_runslot"
                                RunSlot = CInt(Val(CollectFields(sa)))
                            Case Else
                                MessageBox.Show("Unrecognized command """ + l + """", _
                                                "Message from Theremino Voice", _
                                                MessageBoxButtons.OK)
                        End Select
                        Continue For
                    End If
                    ' ------------------------------------------ decode words
                    Dim srw As SR_Word = New SR_Word
                    srw.lineIndex = LineIndex
                    srw.word = sa(0).ToLower
                    If sa.Length > 1 Then
                        Select Case sa(1).ToLower
                            Case "load", "loadtts"
                                ' ------------------------------ add "LoadSR", "LoadTTS" words
                                srw.cmd = sa(1).ToLower
                                ReDim srw.cmdParams(sa.Length - 3)
                                For i As Int32 = 2 To sa.Length - 1
                                    srw.cmdParams(i - 2) = sa(i)
                                Next
                            Case Else
                                ' ------------------------------ add numeric values
                                ReDim srw.values(sa.Length - 2)
                                For i As Int32 = 1 To sa.Length - 1
                                    If sa(i).Contains("x") Then
                                        srw.values(i - 1) = NAN_Sleep
                                    Else
                                        srw.values(i - 1) = CSng(Val(sa(i)))
                                    End If
                                Next
                        End Select
                    End If
                    ' ------------------------------------------ add word to SR_Words array
                    ReDim Preserve SR_Words(SR_Words.Length)
                    SR_Words(SR_Words.Length - 1) = srw
                End If
            End If
        Next
    End Sub

    Private Function CollectFields(ByVal sa() As String) As String
        CollectFields = ""
        For i As Int32 = 1 To sa.Length - 1
            If i = 1 And sa(1) = "=" Then Continue For
            CollectFields += sa(i) + " "
        Next
        CollectFields = CollectFields.Trim
    End Function

    Friend SayValidPrefixText As String = "Valid words"
    Private Sub SayValidWords(Optional ByVal recognizedWord As String = "")
        Dim s As String = ""
        If SayType >= SayTypes.SayOneWord Then
            If recognizedWord <> "" Then
                s += SayRecognizedTitle + " " + recognizedWord + vbCrLf
            End If
        End If
        If SayType = SayTypes.SayAllWords Then
            s += SayValidPrefixText + ":"
            For i As Int32 = 0 To SR_Words.Length - 1
                s += "  " + SR_Words(i).word
            Next
        End If
        If s <> "" Then
            _tts.Rate = 2
            Speak(s)
        End If
    End Sub

    Friend SayRecognizedTitle As String = "OK"
    Private Sub SayRecognizedWord(ByVal text As String)
        If SayType >= SayTypes.SayOneWord Then
            Dim s As String = SayRecognizedTitle + " " + text
            _tts.Rate = 2
            Speak(s)
        End If
    End Sub

    ' ====================================================================
    '  DECODE RECOGNIZED WORD
    ' ====================================================================
    Private FirstSlot As Int32 = 1
    Private RunSlot As Int32 = -1
    Private Confidence As Single = 0.6
    Private Sub DecodeRecognizedWorld(ByVal result As Microsoft.Speech.Recognition.RecognitionResult)
        ' ------------------------------------------------------------------ show results
        'Text = Result.Homophones.Count.ToString
        'Text = Result.Words.Count.ToString
        'Text = Result.Audio.Duration.ToString
        'Text = result.Confidence.ToString()
        ' ------------------------------------------------------------------ limit by Confidence
        If result.Confidence < Confidence Then Return
        ' ------------------------------------------------------------------ decode
        Dim str As String = result.Text
        For Each word As SR_Word In SR_Words
            If word.word = str.ToLower Then
                Select Case word.cmd
                    Case "load"
                        StopSREngine()
                        SaveRecogFile()
                        RecogTextFile = word.cmdParams(0)
                        ReadRecogFile()
                        ParseSrLines()
                        StartSREngine()
                        SayValidWords(word.word)
                        Exit For
                    Case "loadtts"
                        SpeechTextFile = word.cmdParams(0)
                        ReadSpeechFile()
                        ParseTtsLines()
                    Case Else
                        ' --------------------------------------------------- slots
                        SayRecognizedWord(word.word)
                        If word.values IsNot Nothing Then
                            For i As Int32 = 0 To word.values.Length - 1
                                If Not IsNanSleep(word.values(i)) Then
                                    Slots.WriteSlot(FirstSlot + i, word.values(i))
                                End If
                            Next
                        End If
                End Select
                ' --------------------------------------------------- 
                TextBox_SelectLine(txt_ValidWords, word.lineIndex)
                ' ---------------------------------------------------
                Exit For
            End If
        Next
    End Sub

End Class


' --------------------------------------------------
'  TODO main list
' --------------------------------------------------
' nothing to do

' --------------------------------------------------
'  DONE main list
' --------------------------------------------------
' File name on window title
' Horizzontal separator
' ITA ENG files
' Parse TTS text
' reenable after speech